<script lang="ts">
    import type { ValidationResult } from "@/utils/form_validation";
	import { Label, TextField } from "attractions";
	import { enhance } from "$app/forms";

	export let validation_results: {[key: string]: ValidationResult} | undefined = undefined;

	/**
	 * [[Label, Name, Type, Icon, Default value, ...restparams], ...]
	 */
	export let fields: any[][];

	export let width: string = "fit-content";
	export let form_action: string = "";
	export let use_enhance = true;
</script>

<div class="card-wrapper" style={`width: ${width}`}>
	{#if use_enhance} <!-- Only use enhance changes -->
	<form method="post" action={form_action} class="card-form" use:enhance>
		{#each fields as field}
			{@const [label, name, type, icon, default_value, restprops] = field}
			<TextField
				outline
				{label}
				withItem
				{name}
				{type}
				{...restprops}
				value={validation_results?.[name]?.field_value ?? default_value}
				error={
					(validation_results?.[name]?.missing && "A mező kitöltése kötelező!")
					||
					(validation_results?.[name]?.valid === false && `Hibás ${label.toLowerCase()}`)
				}
			>
				<i class="item material-icons">{icon}</i>
			</TextField>
		{/each}
		<slot name="fields">
		</slot>
		<Label small class="suggestion">
			<slot name="suggestion">
			</slot>
		</Label>
		<div class="actions">
			<slot name="actions">
			</slot>
		</div>
	</form>
	{:else}
	<form method="post" action={form_action} class="card-form">
		{#each fields as field}
			{@const [label, name, type, icon, default_value, restprops] = field}
			<TextField
				outline
				{label}
				withItem
				{name}
				{type}
				{...restprops}
				value={validation_results?.[name]?.field_value ?? default_value}
				error={
					(validation_results?.[name]?.missing && "A mező kitöltése kötelező!")
					||
					(validation_results?.[name]?.valid === false && `Hibás ${label.toLowerCase()}`)
				}
			>
				<i class="item material-icons">{icon}</i>
			</TextField>
		{/each}
		<slot name="fields">
		</slot>
		<Label small class="suggestion">
			<slot name="suggestion">
			</slot>
		</Label>
		<div class="actions">
			<slot name="actions">
			</slot>
		</div>
	</form>
	{/if}
</div>

<style>
	.card-form {
		display: flex;
		flex-direction: column;
		row-gap: 12px;
	}
	.actions {
		display: flex;
		justify-content: end;
	}
</style>
